/*
	Copyright (c) 1992, 1993, 1994, 1995  AXE,Inc.
 */

/*
	regs.h
	ͭΥ쥸ˤĤƤ

*/


#ifndef _REGS_H
#define _REGS_H

#define MODE_USER	(0x00000000)
#define MODE_SUPER	(0x40000000)
#define SYSTEM_STACK	(0x80000000)


struct Regs_area{
	long	r0;	/* return value */
	long	r1;
	long	r2;
	long	r3;
	long	r4;	/* 1st argument */
	long	r5;	/* 2nd argument */
	long	r6;	/* 3rd argument */
	long	r7;	/* 4th argument */
	long	r8;
	long	r9;
	long	r10;
	long	r11;
	long	r12;
	long	r13;
	long	r14;
	long	sp;	/* r15 */
	long	sr;	/* status register */
	long	gbr;	/* global base register */
	long	mach;	/* multiply&add  high */
	long	macl;	/* multiply&add  low */
	long	pr;	/* procedure register (return address) */
	long	pc;	/* program counter */
};
#define REGS_AREA	struct Regs_area

#define REGS_MAX        (sizeof(REGS_AREA)/sizeof(long))


#define MESSAGE_REG	0	/* r0ȤäơץϤ*/


#define ARGS_REG	4	/* r4-r7 */
#define syscall_arg(regs,arg_no) \
	(((BYTE4 *)(regs))[(arg_no)+ARGS_REG])
				/* ƥॳΰ */

#define set_register(regs,reg_no,value) \
	(((BYTE4 *)(regs))[reg_no]=(value))


#define status_level(regs)	(((regs)->sr)&MODE_SUPER)
#define system_stack_p(regs)	(((regs)->sp)&SYSTEM_STACK)

void RegsInit();
/*
	void RegsInit(regs,level,start_address)
	REGS_AREA *regs;
	int level;
	int *start_address;

	ץΥ쥸
*/


void RegsCopy();
/*
	void RegsCopy( dis, src )
	REGS_AREA *dis;
	REGS_AREA *src;

	쥸¤Υԡ
*/
#endif _REGS_H
